## game.py
#
#  Définit le Game Play
#
#############################################################################

import GameLogic as gl
from time import sleep

scenes = gl.getSceneList()

def main():
    tempo()
    print_some()
    display_when_problem()
    set_good_level_scene()

    # Si balle sort du jeu
    ball_out()
    # Si reset
    ball_in_center()

    # Piloté par get_osc.py avec gl.rank_scene
    overlay_scene_rank()

    # Niveau 1
    if gl.level == 1:
        level_1_main()
    # Pour tous les autres niveaux
    else:
        ball_bat_goal_score()
        bat_block()
        positive_score()
        set_score()
        overlay_scene_rank()
        bug_Rank()

def level_1_main():
    # Machine n'est pas géré par le serveur
    positive_score()
    set_score()
    bat_block()

    if gl.level1_rated == 0:
        automatic_bat()
    classement_level1()

def display_rank_level1():
    # Comptage du temps d'affichage seulement level 1
    if gl.rank_scene == 1 or gl.rank_scene == 2:
        gl.tempo_rank_level1 += 1
        if gl.tempo_rank_level1 > 120:
            # Fin de la scène Rank
            gl.rank_scene = 0
            reset_variables()

def classement_level1():
    # Classement du joueur et de la machine au niveau 1. 2 Cas
    # Cas 1: je gagne, machine perds
    if gl.level1_rated == 0:
        if gl.goal[1]["score"] == 0: # score machine
            gl.classement_level1['machine']  = 2
            gl.classement_level1[gl.my_name] = 1
            # Je ne repasserai plus par ici
            gl.level1_rated = 1
            # demande de la scèneRank
            gl.rank_scene = 1
            print("Dans niveau 1, j'ai gagné")

        # Cas 2: je perds, machine gagne
        if gl.goal[0]["score"] == 0: # mon score
            gl.classement_level1['machine']  = 1
            gl.classement_level1[gl.my_name] = 2
            # Je ne repasserai plus par ici
            gl.level1_rated = 1
            # demande de la scèneRank
            gl.rank_scene = 1
            print("Dans niveau 1, machine a gagné")
    else:
        # calcul du temps d'affichage
        display_rank_level1()

def bug_Rank():
    # Correction du bug: Rank encore affiché pendant jeu
    if gl.rank_display_bug > 60:
        print("Correction Bug Rank")
        gl.rank_display_bug = 0
        gl.rank_scene = 0

def overlay_scene_rank():
    # Ajout de la scène Rank si 1
    if gl.rank_scene == 1:
        for scn in scenes :
            if not "Rank" in scn.name:
                # 2 signifie que Rank est affiché
                gl.rank_scene = 2
                # Overlay la scène Rank
                gl.addScene("Rank")

    # Suppression de la scene Rank si 0
    if gl.rank_scene == 0:
        for scn in scenes :
            if "Rank" in scn.name:
                scn.end()
                print("Suppression de Rank")

def set_good_level_scene():
    ## Lance la scene au bon niveau si un joueur arrive ou quitte le jeu
    # La bonne scène est-elle affichée ?
    scene_ok = 0
    for scn in scenes :
        if scn.name == str(gl.level) + "_players" :
            scene_ok = 1

    # Si la scène n'est pas ok
    if scene_ok == 0:

        # Suppression de la mauvaise scène en cours, c'est forcément une scène avec "_players"
        for n in range(1, 11):
            for scn in scenes :
                if scn.name == str(n) + "_players" :
                    scn.end()
                    print("Suppression de la scène", str(n) + "_players")
        # Lancement du bon niveau
        gl.addScene(str(gl.level) + "_players")
        print("Ajout de la scène ", str(gl.level))
        reset_variables()

def reset_score():
    # Reset des scores du niveau en cours
    for i in range(gl.level):
        gl.goal[i]["score"] = 9
    # Il manque la machine au niveau 1: goal[1] existe toujours !
    gl.goal[1]["score"] = 9

def reset_variables():
    ### Reset de variables pour repartir à zéro

    gl.rank_display_bug = 0

    reset_score()
    gl.tempo_globale = 0
    # level 1 only
    gl.level1_rated = 0 # si classement du level 1 fait dans game.py
    gl.classement_level1 = {}
    gl.tempo_rank_level1 = 0
    # pour afficher le classement si j'ai perdu
    gl.rank_scene = 0
    # Le dictionnaire de classement des joueurs
    gl.classement = {}
    # blocage de la bat si j'ai fini
    gl.block = 0

def ball_in_center():
    # Balle au centre si reset avec R
    if gl.sendosc["reset"] == True:
        gl.ball.localPosition = [0, 0, 1]

def ball_out():
    # Ball au centre si la balle sort du jeu
    for scn in scenes:
        if "_players" in scn.name:
            if gl.ball.localPosition[0] < -12:
                gl.ball.localPosition = [0, 0, 1]
            elif gl.ball.localPosition[0] > 12:
                gl.ball.localPosition = [0, 0, 1]
            elif gl.ball.localPosition[1] < -12:
                gl.ball.localPosition = [0, 0, 1]
            elif gl.ball.localPosition[1] > 12:
                gl.ball.localPosition = [0, 0, 1]

def automatic_bat():
    ### Seulement niveau 1. Mouvement auto de la raquette machine
    for scn in scenes :
        if scn.name == "1_players":
            y = 0.7 * gl.ball.localPosition[1]
            gl.bat[1].localPosition = [9.5, y, 1]

def display_when_problem():
    ### Affichage des problèmes réseaux et du nombre de joueurs en cours
    for scn in scenes :
        # Seulement avec la scène réseau OSC
        if scn.name == "OSC":
            if gl.network_problem == 1 :
                gl.getosc["Text"] = "Problème avec le réseau, le routeur ou le serveur"
            elif gl.text_rank == 1:
                gl.getosc["Text"] = "Affichage du score"
            else:
                gl.getosc["Text"] = "Nombre de joueur =  " + str(gl.level) + "\n" + "Aide = H"

def ball_bat_goal_score():
    ### Gère les ball, bat, goal, et les scores doivent être >= 0
    for scn in scenes :
        if "_players" in scn.name :
            positive_score()
            set_score()
            bat_block()
            other_bat_position()

            # Si je suis pas le premier
            ball_position()

            if gl.debug == 1:
                bat_move_auto()

def bat_block():
    for scn in scenes:
        if "_players" in scn.name:
            if gl.goal[gl.Iam]["score"] == 0:
                gl.block = 1
            if gl.block == 0:
                gl.bat[gl.Iam]["activ"] = 1
            if gl.block == 1:
                gl.bat[gl.Iam]["activ"] = 0

def set_score():
    # Set score avec les scores de players_data
    for scn in scenes:
        if "_players" in scn.name:
            # Sauf niveau 1 qui est en local
            if gl.level > 1:
                for player in range(gl.level):
                    if player != gl.Iam:
                        gl.goal[player]["score"] = gl.players_data[player][8]

def other_bat_position():
    ## Définir les positions des raquettes des autres joueurs, pas pour moi,
    # sauf en mode debug
    if gl.debug == 0:
        for player in range(gl.level):
            if player != gl.Iam:
                gl.bat[player].localPosition = [gl.players_data[player][5],
                                                gl.players_data[player][6], 1]

def ball_position():
    ## Placer la balle si je ne suis pas master
    # Le premier dans la liste des jouers est toujours le master, sauf la machine
    if gl.Iam != 0 :
        if gl.players_data[0][0] != 'machine':
            # Disable rigid body de la balle
            gl.ball["master"] = False
            # Set position
            gl.ball.localPosition = [gl.players_data[0][2], gl.players_data[0][3], 1]

def positive_score():
    for scn in scenes:
        if "_players" in scn.name:
            # Tous les scores doivent être >= 0
            if gl.level == 1:
                b = 2 # le niveau 1 a 2 joueurs
            else:
                b = gl.level
            for g in range(b):
                if gl.goal[g]["score"] <= 0:
                    gl.goal[g]["score"] = 0

def bat_move_auto():
    ## Déplacement auto des raquettes en mode debug
    for other in range(gl.level):
        if other != gl.Iam:
            if gl.tempo_globale < 120 :
                a = 0.05
            if gl.tempo_globale >= 120 :
                a = -0.05
            # Set amount to move
            movement = [ 0.0, a, 0.0]
            # Use local axis
            local = True
            # Move game object
            try:
                gl.bat[other].applyMovement(movement, local)
            except:
                pass

def print_some():
    #if gl.tempo_globale % 10 == 0:
    if gl.tempo_globale == 0:
        #print('Ball x local Position = {0:.2f}'.format(gl.ball.localPosition[0]))
        #print( 'Score joueur 0 = {0:.2f} Score joueur 1 = {1:.2f}'.format(gl.goal[0]["score"], gl.goal[1]["score"]) )
        print("gl.classement", gl.classement)

def tempo():
    if gl.debug == 1:
        if gl.getosc["pause"] == True:
            sleep(0.1)

    # Tempo, reset toutes les 120 frames soit 2 secondes
    gl.tempo_globale += 1
    if gl.tempo_globale > 120:
        gl.tempo_globale = 0

cont = gl.getCurrentController()
sens = cont.sensors["Game"]
if sens.positive:
     main()

