## init.py
#
# Ce script est lancé au début du jeu, et défini
#    des variablel
#    des dictionaires
#    trouve mon IP
#    Toutes les variables sont sauvegardé dans le GameLogic as gl
#############################################################################

import GameLogic as gl
import subprocess,re, socket
from functools import reduce
import subprocess
import sys

def main():
    set_variables()
    get_my_ip()
    # Relay
    run_script()

def set_variables():
    # Variables
    gl.network_problem = 0 # in game.py
    gl.connected = False # if socket Get OSC is connected or not
    gl.tempo_globale = 0

    gl.data = [] # data from get_osc.py
    gl.players_data = [] # players_data list

    # gl.level est le niveau du jeu, donc égal au nombre de jouer dans players_data,
    # sauf au niveau 1, où il y a 2 joueurs! un joueur + machine
    gl.level = 1

    # level 1 only
    gl.level1_rated = 0 # si classement du level 1 fait dans game.py
    gl.classement_level1 = {}
    gl.tempo_rank_level1 = 0

    # ma position dans la liste players_data
    gl.Iam = 0

    # mon nom
    gl.my_name = "toto"

    # pour afficher le classement si j'ai perdu
    gl.rank_scene = 0
    # Pour n'afficher Rank qu'une seule fois dans get_osc.py
    gl.final_display_received = 0
    gl.rank_display_bug = 0

    # Message erreur dans sendosc pendant rank
    gl.text_rank = 0

    # Le dictionnaire de classement des joueurs
    gl.classement = {}

    # blocage de la bat si j'ai fini
    gl.block = 0

    # All bat
    gl.bat = {  0 : 0,
                1 : 1,
                2 : 2,
                3 : 3,
                4 : 4,
                5 : 5,
                6 : 6,
                7 : 7,
                8 : 8,
                9 : 9}

    # All goal to access score
    gl.goal = {  0 : 0,
                1 : 1,
                2 : 2,
                3 : 3,
                4 : 4,
                5 : 5,
                6 : 6,
                7 : 7,
                8 : 8,
                9 : 9   }

    # Players added with [+], deleted with [-], simul players to debug
    gl.simul = [['192.168.1.22',  '/ball', 0 ,0 , '/bat', -4, 1, '/score', 5, '/name', 'labomedia', '/rank', 0],
                ['192.168.1.26',  '/ball', 0 ,0 , '/bat', -3, 2, '/score', 9, '/name', 'toto', '/rank', 0],
                ['192.168.1.27',  '/ball', 0 ,0 , '/bat', -2, 3, '/score', 8, '/name', 'yoyo', '/rank', 4],
                ['192.168.1.28',  '/ball', 0 ,0 , '/bat', -1, 4, '/score', 7, '/name', 'amour', '/rank', 0],
                ['192.168.1.29',  '/ball', 0 ,0 , '/bat', 1, 5, '/score', 6, '/name', 'freedom', '/rank', 6],
                ['192.168.1.23',  '/ball', 0 ,0 , '/bat', 2, -1, '/score', 5, '/name', 'tata', '/rank', 7],
                ['192.168.1.25',  '/ball', 0 ,0 , '/bat', 3, -2, '/score', 4, '/name', 'titi', '/rank', 8],
                ['192.168.1.30', '/ball', 0 ,0 , '/bat', 4, -3, '/score', 3, '/name', 'arts', '/rank', 9],
                ['192.168.1.31', '/ball', 0 ,0 , '/bat', 5, -4, '/score', 3, '/name', 'num', '/rank', 10] ]

def get_my_ip():
    # Get local ip
    #A generator that returns stripped lines of output from "ip address show"
    iplines=(line.strip() for line in subprocess.getoutput("ip address show").split('\n'))

    #Turn that into a list of IPv4 and IPv6 address/mask strings
    addresses1=reduce(lambda a,v:a+v,(re.findall(r"inet ([\d.]+/\d+)",line)+re.findall(r"inet6 ([\:\da-f]+/\d+)",line) for line in iplines))

    #Get a list of IPv4 addresses as (IPstring,subnetsize) tuples
    ipv4s=[(ip,int(subnet)) for ip,subnet in (addr.split('/') for addr in addresses1 if '.' in addr)]

    gl.local_ip = ipv4s[1][0]

    print()
    print("From Script init.py")
    print(" My IP = {} \n Incomming Port = {} \n Outgoing Port = {} \n".format(gl.local_ip, gl.port_in, gl.port_out))

def run_script():
    # Run external script Relay
    path = sys.path[0]
    script = path + "/Relay/relay.py"

    gl.relay_subprocess = subprocess.Popen(['python ' + script +';read'],
                            stdout = subprocess.PIPE, stderr = subprocess.PIPE, shell=True)
    ##gl.relay_subprocess = subprocess.Popen(['xterm -e python '+script+';read'],
                ##stdout = subprocess.PIPE, stderr = subprocess.PIPE, shell=True)

cont = gl.getCurrentController()
sens = cont.sensors["once"]
if sens.positive:
     main()
