## send_data.py
#
#  Lancé  à chaque frame pour envoyer les messages OSC au server via Relay.
#
#############################################################################

import GameLogic as gl
from OSC3.OSC import OSCClient, OSCMessage

# Get all scenes
scenes = gl.getSceneList()

addr_out = gl.local_ip, gl.port_out
clt = OSCClient()
clt.connect(addr_out)

def main():
    message_particulier()
    message_a_chaque_frame()

def message_a_chaque_frame():
    # Valeurs par défaut à envoyer
    score = [11]
    bat_loc = [0, 0]
    ball_loc = [0, 0]

    # Valeurs actualisées à envoyer
    for scn in scenes:
        if "_players" in scn.name:

            # Ball:
            ball_loc = [gl.ball.localPosition[0], gl.ball.localPosition[1]]

            # Ma position de Bat et mon score
            score = gl.goal[gl.Iam]["score"]
            bat_loc = [gl.bat[gl.Iam].localPosition[0], gl.bat[gl.Iam].localPosition[1]]

    if score == 11:
        gl.getosc["Text"] = "Problem with Score in send_data.py"

    # Création du message complet
    send_message('/player_data', ['/ball', ball_loc, '/bat', bat_loc, '/score', score,
                '/name', gl.my_name])

def message_particulier():
    ## Message particulier
    # Quit
    if gl.sendosc["quit"]:
        send_message('/quit', 1)
        print('OSC message /quit sended')

        print("Fin du processus avec PID = ", gl.relay_subprocess.pid)
        # Fin du subprocessus
        gl.relay_subprocess.terminate()

    # Reset
    if gl.sendosc["reset"] == 1:
        gl.sendosc["reset"] = 0
        send_message('/reset', 1)
        print('OSC message /reset sended')

    # New Game
    if gl.sendosc["reset_game"] == 1:
        gl.sendosc["reset_game"] = 0
        send_message('/reset_game', 1)
        print('OSC message /new_game sended')

def send_message(title, message):
    m = OSCMessage(title)
    m.append(message)
    try:
        clt.send(m)
    except:
        pass

cont = gl.getCurrentController()
sens = cont.sensors["Game"]
if sens.positive:
     main()
